Recent

Author Topic: Fpcupdeluxe  (Read 356262 times)

DonAlfredo

  • Hero Member
  • *****
  • Posts: 1121
Re: Fpcupdeluxe
« Reply #1305 on: July 04, 2019, 12:30:54 pm »
When building a cross-compiler, the available sources are not touched.
Patches are only applied when installing/updating FPC itself.

Do I understand you correctly that you only want to patch the FPC sources when building a certain cross-compiler ?

SymbolicFrank

  • Hero Member
  • *****
  • Posts: 635
Re: Fpcupdeluxe
« Reply #1306 on: July 04, 2019, 01:00:31 pm »
Yes, the cross-compiler adds a lot of device configuration files, which are incomplete.

af0815

  • Sr. Member
  • ****
  • Posts: 344
Re: Fpcupdeluxe
« Reply #1307 on: July 05, 2019, 06:32:12 am »
Actual i see on fixes32 (fpc) and fixes20 (laz) an not stopping error ? warning ?
DE: make (e=87): Falsche Parameter
EN: make (e=87): The parameter is incorrect

Building of Lazarus is finished, but ?!?
regards
Andreas

af0815

  • Sr. Member
  • ****
  • Posts: 344
Re: Fpcupdeluxe
« Reply #1308 on: July 05, 2019, 08:02:07 am »
Actual it look it is not possible to UPDATE an existing installation to fpc fixes32 and Lazarus fixes20 with installed Sparta Docked Form Editor in fpcupdeluxe. The building of Lazarus breaks.

There is a reported Bug https://bugs.freepascal.org/view.php?id=35721 which inhibit a working installation of Lazarus. A actual workaround is to fix the fpc fixes32 to Version 42284 because the changes in Rev 42306 breaks the update.

A fresh installation of lazarus without extra packages is possible (see my previous post). The same issue raises later if you install the packages for docked forms.
 
regards
Andreas

DonAlfredo

  • Hero Member
  • *****
  • Posts: 1121
Re: Fpcupdeluxe
« Reply #1309 on: July 05, 2019, 08:45:41 am »
If you want to file a FPC or Lazarus bugger, it is best to try to reproduce this bugger without fpcupdeluxe. In that way, you (and the FPC and Lazarus devs) can be sure that the bugger is not caused by fpcupdeluxe itself.

The make-error is harmless.

af0815

  • Sr. Member
  • ****
  • Posts: 344
Re: Fpcupdeluxe
« Reply #1310 on: July 05, 2019, 08:58:45 am »
The make-error is harmless.
THX for the Info

The other is an existing Bug in the tracker, but if you want to upgrade you find it on your PC :-) So its more for the record.  It depends NOT on fpcupdeluxe, recompile Lazarus with an upgraded fpc is enough.
regards
Andreas

circular

  • Hero Member
  • *****
  • Posts: 2954
    • Personal webpage
Re: Fpcupdeluxe
« Reply #1311 on: July 06, 2019, 11:01:18 am »
I have trouble with cross compiling to Linux 32 bit. When adding a release mode for Linux 32 it says that "/usr/bin/fpc" doesn't support the target i386-linux.

If I try to compile anyway it says:
Error: ppc386 can't be executed, error message: Failed to execute "ppc386", error code: 127

I found a wiki page that apparently explains how to do. I applied that but that doesn't solve the problem.
https://wiki.lazarus.freepascal.org/Cross_compiling#From_Linux_x64_to_Linux_i386

Now I found that fpcupdeluxe provides cross-compiling stuff. I downloaded the file "CrossBinsLinuxi386.zip" from:
https://github.com/LongDirtyAnimAlf/fpcupdeluxe/releases/tag/linuxx64crossbins_v1.0

It contains lots of i386-linux-... files but I have no idea what to do with them.
Conscience is the debugger of the mind

DonAlfredo

  • Hero Member
  • *****
  • Posts: 1121
Re: Fpcupdeluxe
« Reply #1312 on: July 06, 2019, 11:49:59 am »
To cross-compile, you have to build a cross-compiler.
The FPC wiki contains a lot of info on how to accomplish that.

An easy start will also be possible with fpcupdeluxe.
First, use fpcupdeluxe to install a FPC and Lazarus version of your choice in a location (directory) of your choice). You might try FPC and Lazarus trunk. But latest fixes of both is also a good choice.
Second, use fpcupdeluxe to build a cross-compiler.

When the two step above have been successfully finished (keep thumbs crossed), you can have a look at the various settings on how this has been setup (e.g. fpc.cfg).

lainz

  • Hero Member
  • *****
  • Posts: 3197
    • Lainz
Re: Fpcupdeluxe
« Reply #1313 on: July 06, 2019, 02:42:08 pm »
I built LazPaint 7 with FPCUpDeluxe cross compiler from Win32 to Linux32 and Linux64. When I try to run the binary file on Puppy Linux (32 and 64 as well), it says "Cannot execute binary file: Exec format error".

But the binary file compiled on Linux 64 by circular works fine on puppy linux 64.

Any ideas?

Edit: this is still neccessary?
https://forum.lazarus.freepascal.org/index.php/topic,34681.0.html

Edit2: as well the deb file of LazPaint compiled by circular contains the lib folder, that folder is neccessary to be redistributed as well?
« Last Edit: July 06, 2019, 02:53:35 pm by Lainz »

circular

  • Hero Member
  • *****
  • Posts: 2954
    • Personal webpage
Re: Fpcupdeluxe
« Reply #1314 on: July 06, 2019, 03:07:16 pm »
Ok I will try to do the full thing with fpcupdeluxe and see how it goes.
Conscience is the debugger of the mind

DonAlfredo

  • Hero Member
  • *****
  • Posts: 1121
Re: Fpcupdeluxe
« Reply #1315 on: July 07, 2019, 01:10:06 pm »
@Lainz
I just crossed the latest LazPaint from GitHub with FPC and Lazarus trunk from win32 towards Linux x64. The resulting executable runs flawless on a Ubuntu64 VM.
So, I am in the dark about your problem.

See included screenshot.

circular

  • Hero Member
  • *****
  • Posts: 2954
    • Personal webpage
Re: Fpcupdeluxe
« Reply #1316 on: July 07, 2019, 02:19:38 pm »
Hi DonAlfredo

The problem we have is towards Linux 32, not 64.

I am trying with fpcupdeluxe. It installs 64 bit version and then when I try to cross-compile it goes through everything but in the end I get "error while linking".

Could I simply install 32 bit version of Lazarus on my 64 bit Linux with fpcupdeluxe? I already have a 64 bit version on my system anyway.

Regards
« Last Edit: July 07, 2019, 04:23:17 pm by circular »
Conscience is the debugger of the mind

DonAlfredo

  • Hero Member
  • *****
  • Posts: 1121
Re: Fpcupdeluxe
« Reply #1317 on: July 07, 2019, 04:57:37 pm »
Cross-compiled LazPaint 32bit running on Linux Mint without problems. See screenshot.

DonAlfredo

  • Hero Member
  • *****
  • Posts: 1121
Re: Fpcupdeluxe
« Reply #1318 on: July 07, 2019, 05:01:10 pm »
It should be a standard job to install a cross-compiler towards 32 bit. This forum holds plenty of info to accomplish this.
If you need more help, have a look at the missing files when linking (disable filtering of Lazarus messages). That info will show you how to proceed.

circular

  • Hero Member
  • *****
  • Posts: 2954
    • Personal webpage
Re: Fpcupdeluxe
« Reply #1319 on: July 07, 2019, 06:42:27 pm »
Ok I found by right-clicking the messages window some filtering options. Unchecking "Filter hints without source position" gave me some info:
Quote
/usr/bin/ld : escamotage incompatible /usr/lib/gcc/x86_64-linux-gnu/5.4.0/crtbegin.o lors de la recherche de /usr/lib/gcc/x86_64-linux-gnu/5.4.0/crtbegin.o
/usr/bin/ld : ne peut trouver /usr/lib/gcc/x86_64-linux-gnu/5.4.0/crtbegin.o
Something about incompatibility. What then?

By the way thanks for helping out Alf.  :)
« Last Edit: July 07, 2019, 06:46:55 pm by circular »
Conscience is the debugger of the mind